// Engine.IO server-side wrapper
'use strict';

var fs = require('fs');

var openSocketsById = {};

module.exports = function(ss, messageEmitter, httpServer, config){
  config = config || {};
  config.server = config.server || {};
  config.client = config.client || {};

  var api = { event: eventFn };

  return api;

  function eventFn() {
    return {

      // Send the same message to every open socket
      all: function(msg) {
        for (var id in openSocketsById) {
          if (openSocketsById.hasOwnProperty(id)) {
            openSocketsById[id].send('0|' + msg + '|null');
          }
        }
      },

      // Send an event to a specific socket
      // Note: 'meta' is typically the name of the channel
      socketId: function(id, msg, meta) {
        var socket = openSocketsById[id];
        if (socket) {
          return socket.send('0|' + msg + '|' + meta);
        } else {
          return false;
        }
      }
    }
  }
}
